<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="orderId" label="订单ID">
                <el-input v-model="formData.orderId"></el-input>
            </el-form-item>
            <el-form-item prop="reason" label="理由">
                <el-select v-model="formData.reason" clearable filterable placeholder="请选择">
                    <el-option
                            v-for="item in reasonOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="remark" label="备注">
                <el-input v-model="formData.remark"></el-input>
            </el-form-item>
            <el-form-item prop="status" label="状态">
                <el-select v-model="formData.status" clearable filterable placeholder="请选择">
                    <el-option
                            v-for="item in statusOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="applyTime" label="申请时间">
                <el-date-picker
                        v-model="formData.applyTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="auditTime" label="审核时间">
                <el-date-picker
                        v-model="formData.auditTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="refundTime" label="退款时间">
                <el-date-picker
                        v-model="formData.refundTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="refundId" label="退款单号">
                <el-input v-model="formData.refundId"></el-input>
            </el-form-item>
            <el-form-item prop="merchantLiability" label="商家承担">
                <el-input v-model="formData.merchantLiability"></el-input>
            </el-form-item>
            <el-form-item prop="riderLiability" label="骑手承担">
                <el-input v-model="formData.riderLiability"></el-input>
            </el-form-item>
            <el-form-item prop="platformLiability" label="平台承担">
                <el-input v-model="formData.platformLiability"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'OrderRefundApplyEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('orderRefundApply/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {

                },
                rules: {
                },
                statusOptions: [
                    {"label": "待处理", "value": "PENDING"},
                    /*{"label": "退款中","value": "REFUNDING"},*/
                    {"label": "成功", "value": "SUCCESS"},
                    {"label": "失败", "value": "DENY"}],
                reasonOptions: [
                    {"label": "未按约定时间发货", "value": "SHIP_ON_TIME"},
                    {"label": "多拍/错拍商品", "value": "MISTAKE"},
                    {"label": "暂时不想买了", "value": "WANT_TO_BUY"},
                    {"label": "其他", "value": "OTHER"}
                ],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/orderRefundApply/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/orderRefundApply/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
